import type { RuleYEncodeChannels, WithDefaultEncode, BasicEncoderSpecMap, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class RuleY extends SemanticMark<BasicEncoderSpecMap['rule'], RuleYEncodeChannels> {
    static readonly type = PlotMakType.ruleY;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    protected parseScaleOfEncodeX(option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['rule'], RuleYEncodeChannels>, RuleYEncodeChannels>): ScaleSpec | Nil;
    parseScaleByEncode(channel: RuleYEncodeChannels, option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['rule'], RuleYEncodeChannels>, RuleYEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<BasicEncoderSpecMap['rule'], RuleYEncodeChannels>): GenerateBaseEncodeSpec<BasicEncoderSpecMap['rule']>;
}
